#   ConVirt   -  Copyright (c) 2008 Convirture Corp.
#   ======
#
# ConVirt is a Virtualization management tool with a graphical user
# interface that allows for performing the standard set of VM operations
# (start, stop, pause, kill, shutdown, reboot, snapshot, etc...). It
# also attempts to simplify various aspects of VM lifecycle management.
#
#
# This software is subject to the GNU General Public License, Version 2 (GPLv2)
# and for details, please consult it at:
#
# http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt
# author : Jd <jd_jedi@users.sourceforge.net>

import pylons
import simplejson as json
import traceback
from convirt.lib.base import BaseController
from tg import expose, flash, require, url, request, redirect,response,session,config
from convirt.model.CustomPredicates import authenticate
from convirt.model import *
from convirt.model.DBHelper import DBHelper
from convirt.viewModel.Userinfo import Userinfo
from convirt.core.utils.utils import to_unicode,to_str
import convirt.core.utils.constants
constants = convirt.core.utils.constants
import logging,tg,os
LOGGER = logging.getLogger("convirt.controllers")

class ModelController(BaseController):
    """
    
    """

    #allow_only = authenticate()
    #/model/
    @expose('convirt.templates.login')
    def authenticate(self, came_from=url('/')):
        if session.get('userid') is None:
            try:
                redirect(url('/login', came_from=came_from, __logins=0))
            except Exception, e:
                #traceback.print_exc()
                raise Exception("SessionExpired.")

    @expose(template='json')
    def get_users(self,_dc=None):
        try:
            self.authenticate()
            result = None
            result=Userinfo().get_users()
        except Exception, ex:
            print ex
            return dict(success=False,msg=to_str(ex).replace("'",""))
        return dict(success=True,rows=result)

    @expose(template='json')
    def get_user_status_map(self,_dc=None):
        result = None
        self.authenticate()
        result=Userinfo().get_user_status_map()
        return result

    @expose(template='json')
    def save_user_det(self, userid, username, fname, lname, displayname, password, email, phone, status,groupids):
          try:
              result = None
              self.authenticate()
              result = Userinfo().save_user_det( session['userid'],userid, username, fname, lname, displayname, password, email, phone, status,groupids)
          except Exception, ex:
              print ex
              return {'success':False, 'msg':to_str(ex).replace("'", "")}
          return {'success':True, 'user_det':result}

    @expose(template='json')
    def delete_user(self,userid):
        try:
            self.authenticate()
            Userinfo().delete_user(userid)
            return {'success':True, 'msg':'User Removed.'}
        except Exception, ex:
            print ex
            return {'success':False, 'msg':to_str(ex).replace("'", "")}

    @expose(template='json')
    def updatesave_user_det(self, userid, username, fname, lname, displayname,  email, phone, status,groupids,changepass,newpasswd):
          try:
              result = None
              self.authenticate()
              result = Userinfo().updatesave_user_det(session['userid'],userid, username, fname, lname, displayname,  email, phone, status,groupids,changepass,newpasswd)
          except Exception, ex:
              print ex
              return {'success':False, 'msg':to_str(ex).replace("'", "")}
          return {'success':True, 'user_det':result}


    @expose(template='json')
    def edit_user_det(self,userid):
          try:
              result = None
              self.authenticate()
              result = Userinfo().edit_user_det(userid)
          except Exception, ex:
              print ex
              return {'success':False, 'msg':to_str(ex).replace("'", "")}
          return {'success':True, 'edit_user_det':result}

    @expose(template='json')
    def change_user_password(self, userid, newpasswd, oldpasswd):
        try:
            result = None
            self.authenticate()
            result = Userinfo().change_user_password(userid, newpasswd, oldpasswd)
        except Exception, ex:
            print ex
            return {'success':False, 'msg':to_str(ex).replace("'", "")}
        return {'success':True, 'user_det':result}

    @expose(template='json')
    def get_opsgroups(self,_dc=None):

        try:
            self.authenticate()
            result = None
            result=Userinfo().get_opsgroups()
        except Exception, ex:
            print ex
            return dict(success=False,msg=to_str(ex).replace("'",""))
        return dict(success=True,rows=result)

    @expose(template='json')
    def get_entities(self,enttype_id,_dc=None):

        try:
            self.authenticate()
            result = None
            result=Userinfo().get_entities(enttype_id)
        except Exception, ex:
            print ex
            return dict(success=False,msg=to_str(ex).replace("'",""))
        return dict(success=True,rows=result)

    @expose(template='json')
    def get_groups_map(self,userid=None,_dc=None):
        result = None
        self.authenticate()
        result=Userinfo().get_groups_map(userid)
        return {'success':True, 'group_det':result}

    @expose(template='json')
    def get_users_map(self,groupid=None,_dc=None):
        result = None
        self.authenticate()
        result=Userinfo().get_users_map(groupid)
        return {'success':True, 'user_det':result}

    @expose(template='json')
    def get_togroups_map(self,userid,_dc=None):
        result = None
        self.authenticate()
        result=Userinfo().get_togroups_map(userid)
        return {'success':True, 'togroup_det':result}

    

    @expose(template='json')
    def delete_group(self,groupid):
        try:
            self.authenticate()
            Userinfo().delete_group(groupid)
            return {'success':True, 'msg':'Group Removed.'}
        except Exception, ex:
            print ex
            return {'success':False, 'msg':to_str(ex).replace("'", "")}

    @expose(template='json')
    def get_groupsdetails(self,_dc=None):

        try:
            self.authenticate()
            result = None
            result=Userinfo().get_groupsdetails()
            #print "result", result
        except Exception, ex:
            print ex
            return dict(success=False,msg=to_str(ex).replace("'",""))
        return dict(success=True,rows=result)

    @expose(template='json')
    def save_group_details(self, groupid, groupname, userids,desc):
          try:
              result = None
              self.authenticate()
              result = Userinfo().save_group_details(session['userid'],groupid, groupname, userids,desc)
          except Exception, ex:
              print ex
              return {'success':False, 'msg':to_str(ex).replace("'", "")}
          return {'success':True, 'group_det':result}

    @expose(template='json')
    def updatesave_group_details(self,groupid, groupname, userids,desc):
          try:

              result = None
              self.authenticate()
              result = Userinfo().updatesave_group_details(session['userid'],groupid, groupname, userids,desc)
          except Exception, ex:
              print ex
              return {'success':False, 'msg':to_str(ex).replace("'", "")}
          return {'success':True, 'group_det':result}


    @expose(template='json')
    def edit_group_details(self,groupid):
          try:
              result = None
              self.authenticate()
              result = Userinfo().edit_group_details(groupid)
          except Exception, ex:
              print ex
              return {'success':False, 'msg':to_str(ex).replace("'", "")}
          return {'success':True, 'edit_group_det':result}

    @expose(template='json')
    def get_tousers_map(self,groupid,_dc=None):
        result = None
        self.authenticate()

        result=Userinfo().get_tousers_map(groupid)
        return {'success':True, 'touser_det':result}

    @expose(template='json')
    def save_opsgroup_details(self, opsgroupname, opsgroupdesc, operation):
          try:
              result = None
              self.authenticate()
              result = Userinfo().save_opsgroup_details( session['userid'],opsgroupname, opsgroupdesc, operation)
          except Exception, ex:
              print ex
              return {'success':False, 'msg':to_str(ex).replace("'", "")}
          return {'success':True, 'opsgroup_det':result}

    @expose(template='json')
    def updatesave_opsgroup_details(self, opsgroupid, opsgroupname, opsgroupdesc, operation):
          try:
              result = None
              self.authenticate()
              result = Userinfo().updatesave_opsgroup_details(session['userid'],opsgroupid, opsgroupname, opsgroupdesc, operation)
          except Exception, ex:
              print ex
              return {'success':False, 'msg':to_str(ex).replace("'", "")}
          return {'success':True, 'opsgroup_det':result}

    @expose(template='json')
    def edit_opsgroup_details(self,opsgroupid):
          try:
              result = None
              self.authenticate()
              result = Userinfo().edit_opsgroup_details(opsgroupid)
          except Exception, ex:
              print ex
              return {'success':False, 'msg':to_str(ex).replace("'", "")}
          return {'success':True, 'edit_opsgroup_det':result}


    @expose(template='json')
    def  get_operations_map(self,opsgrpid=None,_dc=None):
        result = None
        self.authenticate()
        result=Userinfo(). get_operations_map(opsgrpid)
        return {'success':True, 'operation_det':result}

    @expose(template='json')
    def get_tooperations_map(self,opsgroupid,_dc=None):
        result = None
        self.authenticate()
        result=Userinfo(). get_tooperations_map(opsgroupid)
        return {'success':True, 'tooperations_det':result}

    @expose(template='json')
    def delete_opsgroup(self,opsgroupid):
        try:
            self.authenticate()
            Userinfo().delete_opsgroup(opsgroupid)
            return {'success':True, 'msg':'Opsgroup Removed.'}
        except Exception, ex:
            print ex
            return {'success':False, 'msg':to_str(ex).replace("'", "")}



    @expose(template='json')
    def get_operations(self,_dc=None):

        try:
            self.authenticate()
            result = None
            result=Userinfo().get_operations()
        except Exception, ex:
            print ex
            return dict(success=False,msg=to_str(ex).replace("'",""))
        return dict(success=True,rows=result)

    @expose(template='json')
    def save_oper_det(self, opname, descr, context_disp, entityid,dispname,icon):
          try:
              result = None
              self.authenticate()
              result = Userinfo().save_oper_det(session['userid'],opname, descr, context_disp, entityid,dispname,icon)
          except Exception, ex:
              print ex
              return {'success':False, 'msg':to_str(ex).replace("'", "")}
          return {'success':True, 'operation_det':result}

    @expose(template='json')
    def edit_op_det(self,opid,enttype):
          try:
              result = None
              self.authenticate()
              result = Userinfo().edit_op_det(opid,enttype)
          except Exception, ex:
              print ex
              return {'success':False, 'msg':to_str(ex).replace("'", "")}
          return {'success':True, 'edit_op_det':result}


    @expose(template='json')
    def updatesave_op_det(self, opid, opname, desc, entid, context_disp,dispname,icon):
          try:
              result = None
              self.authenticate()
              result = Userinfo().updatesave_op_det(session['userid'],opid, opname, desc, entid, context_disp,dispname,icon)
          except Exception, ex:
              print ex
              return {'success':False, 'msg':to_str(ex).replace("'", "")}
          return {'success':True, 'operation_det':result}

    @expose(template='json')
    def delete_operation(self,opid):
        try:
            self.authenticate()
            Userinfo().delete_operation(opid)
            return {'success':True,'msg':'Operation Deleted.'}
        except Exception, ex:
            print ex
            return dict(success=False,msg=to_str(ex).replace("'",""))

    @expose(template='json')
    def get_entitytype_map(self,opid=None,_dc=None):
        result = None
        self.authenticate()
        result=Userinfo().get_entitytype_map(opid)
        #print "result---------", result
        return {'success':True, 'entitytype_det':result}

    @expose(template='json')
    def get_toentitytype_map(self,opid,_dc=None):
        result = None
        self.authenticate()
        result=Userinfo().get_toentitytype_map(opid)
        return {'success':True, 'toentitytype_det':result}   

    @expose(template='json')
    def get_enttype(self,_dc=None):

        try:
            self.authenticate()
            result = None
            result=Userinfo().get_enttype()
            #print "result", result
        except Exception, ex:
            print ex
            return dict(success=False,msg=to_str(ex).replace("'",""))
        return dict(success=True,rows=result)

    @expose(template='json')
    def get_enttype_for_chart(self,_dc=None):

        try:
            self.authenticate()
            result = None
            result=Userinfo().get_enttype_for_chart()
            #print "result", result
        except Exception, ex:
            print ex
            return dict(success=False,msg=to_str(ex).replace("'",""))
        return dict(success=True,rows=result)

    @expose(template='json')
    def save_enttype_details(self, enttypename, dispname):
          try:
              result = None
              self.authenticate()
              result = Userinfo().save_enttype_details(session['userid'],enttypename, dispname)
          except Exception, ex:
              print ex
              return {'success':False, 'msg':to_str(ex).replace("'", "")}
          return {'success':True, 'opsgroup_det':result}

    @expose(template='json')
    def edit_enttype_details(self,enttypeid):
          try:
              result = None
              self.authenticate()
              result = Userinfo().edit_enttype_details(enttypeid)
          except Exception, ex:
              print ex
              return {'success':False, 'msg':to_str(ex).replace("'", "")}
          return {'success':True, 'edit_enttype_det':result}

    @expose(template='json')
    def updatesave_enttype_details(self, enttypeid, enttypename, dispname):
          try:
              result = None
              self.authenticate()
              result = Userinfo().updatesave_enttype_details(session['userid'],enttypeid, enttypename, dispname)
          except Exception, ex:
              print ex
              return {'success':False, 'msg':to_str(ex).replace("'", "")}
          return {'success':True, 'opsgroup_det':result}

    @expose(template='json')
    def delete_enttype(self,enttypeid):
        try:
            self.authenticate()
            Userinfo().delete_enttype(enttypeid)
            return {'success':True, 'msg':'Entitytype Removed.'}
        except Exception, ex:
            print ex
            return {'success':False, 'msg':to_str(ex).replace("'", "")}


