# -*- coding: utf-8 -*-
"""Main Controller"""

__all__ = ['RootController']

import sys

sys.path.append("/usr/lib/python2.4/site-packages")
sys.path.append("/usr/lib64/python2.4/site-packages")
sys.path.append("/usr/lib64/python24.zip")
sys.path.append("/usr/lib64/python2.4/plat-linux2")
sys.path.append("/usr/lib64/python2.4/lib-tk")
sys.path.append("/usr/lib64/python2.4/lib-dynload")
sys.path.append("/usr/lib64/python2.4/site-packages/Numeric")
sys.path.append("/usr/lib64/python2.4/site-packages/gtk-2.0")

import pylons
import simplejson as json
import traceback
from convirt.lib.base import BaseController
from convirt.model import DBSession, metadata
from convirt.controllers.error import ErrorController
from convirt.model.CustomPredicates import is_user
#from convirt.controllers.SecuredAdminController import SecuredAdminController
from convirt.controllers.ApplianceController import ApplianceController
from convirt.controllers.DashboardController import DashboardController
from convirt.controllers.ModelController import ModelController
from convirt.controllers.NodeController import NodeController
from convirt.controllers.NetworkController import NetworkController
from convirt.controllers.StorageController import StorageController
from convirt.controllers.TemplateController import TemplateController

from convirt import model
from convirt.model import *
from convirt.model.DBHelper import DBHelper
from convirt.model.Authorization import AuthorizationService
from convirt.model.UpdateManager import UIUpdateManager
#from convirt.controllers.secure import SecureController
from tg import expose, flash, require, url, request, redirect,response,session,config
from pylons.i18n import ugettext as _, lazy_ugettext as l_
from repoze.what import predicates

from xml.dom import minidom
from convirt.viewModel.TaskInfo import TaskInfo
from convirt.viewModel.Server import Server
#from convirt.viewModel.Sessions import SessionManager
from convirt.viewModel.Message import Message

from convirt.viewModel.NodeService import NodeService
from convirt.viewModel.TaskCreator import TaskCreator
from convirt.viewModel.Userinfo import Userinfo
from convirt.viewModel.EmailService import EmailService
from convirt.core.utils.utils import to_unicode,to_str

import convirt.core.utils.constants
constants = convirt.core.utils.constants

import logging,tg
LOGGER = logging.getLogger("convirt.controllers")
#from catwalk.tg2 import Catwalk
import os
# the global session manager
#sessionManager = SessionManager()

#from tgrum import RumAlchemyController
#from convirt.model.Metrics import MetricsService

class RootController(BaseController):
    
    error = ErrorController()    
    
    appliance=ApplianceController()
    dashboard=DashboardController()
    model=ModelController()
    node=NodeController()
    network=NetworkController()
    storage=StorageController()
    template=TemplateController()
    
    tc = TaskCreator()    

    @expose('convirt.templates.login')
    def login(self, came_from=url('/')):
        """Start the user login."""                
        if session.get('userid') is None and request.identity is not None:
            redirect(url('/logout_handler'))
        login_counter = request.environ['repoze.who.logins']
        if login_counter > 0:
            flash(_('Wrong credentials'), 'warning')
        return dict(page='login', login_counter=to_str(login_counter),came_from=came_from)
    
    @expose()
    def post_login(self, came_from=url('/')):        
        """
        Redirect the user to the initially requested page on successful
        authentication or redirect her back to the login page if login failed.
        """
        result=''
        if not request.identity:
            login_counter = request.environ['repoze.who.logins'] + 1
            result = "{success:false}"
            return result
        userid = request.identity['repoze.who.userid']
        u=User.by_user_name(to_unicode(userid))
        g=Group.by_group_name(to_unicode('adminGroup'))
        auth=AuthorizationService()
        auth.user=u
        session['username']=u.user_name
        session['user_firstname']=u.firstname
        session['has_adv_priv']=tg.config.get(constants.ADVANCED_PRIVILEGES)
        session['PAGEREFRESHINTERVAL']=tg.config.get(constants.PAGEREFRESHINTERVAL)
        session['TASKPANEREFRESH']=tg.config.get(constants.TASKPANEREFRESH)
        session['userid']=userid
        session['auth']=auth        
        session['is_admin']=u.has_group(g)
        session.save()
        result = "{success:true}"
        return result
        
    @expose()
    def post_logout(self, came_from=url('/')):
        """Redirect the user to the initially requested page on logout and say
        goodbye as well."""
        #flash(_('We hope to see you soon!'))
#        sessionInfo = getSession()
#        sessionInfo.logout()
        
        try:
            UIUpdateManager().del_user_updated_entities(session['username'])
            UIUpdateManager().del_user_updated_tasks(session['username'])
        except Exception, e:
            LOGGER.error(to_str(e))
        session.delete()
        redirect(url('/login'))

    @expose(template='convirt.templates.dashboard')
    def index(self):

        """Handle the front-page."""
        try:
            self.authenticate()
        except Exception, e:
            #print "Exception: ", e
            redirect(url('/login'))
        return dict(page='index',user_name=session['username'],\
                                has_adv_priv=session['has_adv_priv'],\
                                is_admin=session['is_admin'],\
                                user_firstname=session['user_firstname'],\
                                TASKPANEREFRESH=session['TASKPANEREFRESH'],\
                                page_refresh_interval=session['PAGEREFRESHINTERVAL'])

    @expose(template='json')
    def get_nav_nodes(self):
        result=[]
        try:
            result=NodeService().get_nav_nodes(session['auth'])
            return dict(success=True,nodes=result)
        except Exception, ex:
            print ex
            return dict(success=False,msg=to_str(ex).replace("'",""))
    
    @expose(template='json')
    def get_vnc_info(self,node_id,dom_id):
        try:
            self.authenticate()
            host=pylons.request.headers['Host']
            (address,port)=host.split(':')            
            result = NodeService().get_vnc_info(session['auth'],node_id,dom_id,address)
        except Exception, ex:
            return dict(success=False,msg=to_str(ex).replace("'", " "))
        return dict(success=True,vnc=result)

    @expose(template='json')
    def get_platforms(self,**kw):
        try:
            self.authenticate()
            result = NodeService().get_platforms()
        except Exception, ex:
            return {'success':'false','msg':to_str(ex).replace("'","")}
        return dict(success='true',rows=result)    
    
    @expose(template='json')
    def get_context_menu_items(self,node_id,node_type,_dc=None,menu_combo=None):
        try:
            self.authenticate()
            result=self.getUserOps(node_id,node_type,menu_combo)
        except Exception, ex:
            print ex
            return dict(success=False,msg=to_str(ex).replace("'",""))
        return dict(success=True,rows=result)

    def getUserOps(self,ent_id,nodeType=None,menu_combo=None):
        result=[]        
        ent=session['auth'].get_entity(ent_id,nodeType)
        if ent is None:
            return result
        ops = session['auth'].get_ops(ent)
        
        for o in ops:
            if o.display==True:
                result.append(dict(value=o.display_id,text=o.display_name,id=o.id,icon=o.icon))
            if menu_combo!='True' and o.has_separator==True:
                    result.append(dict(name='--'))

        return result    
    
    @expose('convirt.templates.login')
    def authenticate(self, came_from=url('/')):
        if session.get('userid') is None:
            try:
                redirect(url('/login', came_from=came_from, __logins=0))
            except Exception, e:
                #traceback.print_exc()
                raise Exception("SessionExpired.")    
    
    @expose(template='json')
    def get_tasks(self,_dc=None):

        try:
            self.authenticate()
            result = None
            result=Userinfo().get_tasks(session['userid'])
        except Exception, ex:
            traceback.print_exc()
            return dict(success=False,msg=to_str(ex).replace("'",""))
        return dict(success=True,rows=result)

    @expose(template='json')
    def getNotifications(self,type,list,user,entType=None,_dc=None):
        try:
            self.authenticate()
            result = None
            result=Userinfo().getNotifications(type,list,user,entType)
        except Exception, ex:
            traceback.print_exc()
            return dict(success=False,msg=to_str(ex).replace("'",""))
        return dict(success=True,rows=result)

    @expose(template='json')
    def getSystemTasks(self,type,user,_dc=None):
        try:
            self.authenticate()
            result = None
            result=Userinfo().getSystemTasks(type,user)
        except Exception, ex:
            traceback.print_exc()
            return dict(success=False,msg=to_str(ex).replace("'",""))
        return dict(success=True,rows=result)

    @expose(template='json')
    def get_failed_tasks(self,_dc=None):

        try:
            self.authenticate()
            result = None
            result=Userinfo().get_failed_tasks(session['userid'])
        except Exception, ex:
            traceback.print_exc()
            return dict(success=False,msg=to_str(ex).replace("'",""))
        return dict(success=True,rows=result)
    
    
    @expose(template='json')
    def save_email_setup_details(self, desc, servername, port, useremail, password, secure, ** kw):
        result = None
        self.authenticate()
        emailservice = EmailService()
        result = emailservice.save_email_setup_details( desc, servername, port, useremail, password, secure )
        return  result
    
    @expose(template='json')
    def update_email_setup_details(self, desc, servername, port, useremail, password, secure, ** kw):
        result = None
        self.authenticate()
        result = EmailService().update_email_setup_details( desc, servername, port, useremail, password, secure)
        return  result
 
 
    @expose(template='json')
    def send_test_email(self, desc, servername, port, useremail, password, secure, ** kw):
        
        #print servername, port, useremail, password, secure
        result = None
        self.authenticate()
        msgreceived = EmailService().send_test_email(desc, servername, port, useremail, password, secure)      
        return  {'success':True, 'msg':msgreceived}
    
    
    @expose(template='json')
    def get_emailsetupinfo(self,_dc=None):
        try:
            self.authenticate()
            result = None
            result=EmailService().get_emailsetupinfo()
        except Exception, ex:
            print ex
            return dict(success=False,msg=to_str(ex).replace("'",""))
        return dict(success=True,rows=result)
    
    @expose(template='json')
    def delete_emailrecord(self,emailsetup_id):
        try:
            self.authenticate()
            EmailService().delete_emailrecord(emailsetup_id)
            return {'success':True, 'msg':'Email Record Deleted.'}
        except Exception, ex:
            print ex
            return {'success':False, 'msg':to_str(ex).replace("'", "")}
        
    @expose(template='json')
    def get_emailsetup_details(self,emailsetup_id):
        try:
            result = None
            self.authenticate()   
            result = EmailService().get_emailsetup_details(emailsetup_id)

        except Exception, ex:
            print ex
            return {'success':False, 'msg':to_str(ex).replace("'", "")}
        return {'success':True, 'emailsetup_details':result}
    
#def getSession():
#    return sessionManager.getSession()
#
#def valid(sessionInfo):
#    return sessionInfo.isValid == 1
#
## this method builds the composite response; it includes a session tag
## and the actual payload for the response in XML form
#def response(sessionInfo, response, tag=None):
#    message = Message(sessionInfo, response, tag)
#    xml = message.toXml()
#    result = xml.toxml("UTF-8")
#    return result

